<?php

namespace App\Exceptions;

use Illuminate\Auth\AuthenticationException;
use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * The list of the inputs that are never flashed to the session on validation exceptions.
     *
     * @var array<int, string>
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Register the exception handling callbacks for the application.
     */
    public function register(): void
    {
        $this->reportable(function (Throwable $e) {
            //
        });
    }

    protected function unauthenticated($request, AuthenticationException $exception)
    {
        if ($request->expectsJson()) {
            return response()->json(['message' => 'Unauthenticated.'], 401);
        }

        if ($request->is('admin') || $request->is('admin/*')) {
            return redirect()->route('admin.login-view');
        }

        if ($request->is('trial-account') || $request->is('trial-account/*')) {
            return redirect()->route('trial-account.login-view');
        }

        if ($request->is('account') || $request->is('account/*')) {
            return redirect()->route('paid-account.login-view');
        }

        if ($request->is('dealer') || $request->is('dealer/*')) {
            return redirect()->route('sub-dealer.login-view');
        }

        if ($request->is('master-dealer') || $request->is('master-dealer/*')) {
            return redirect()->route('master-dealer.login-view');
        }

        return redirect()->guest(route('trial-account.login-view'));
    }
}
